#ifndef BACK_3D_H
#define BACK_3D_H

void init_3d();

void init_sincos();

void placeRectToBuffer(int x, int y, double z, int width, int height, int R, int G, int B);

void drawLineWithThiccToBuffer(int width, double x1, double x2, int y1, int y2, int z1, int z2, int R, int G, int B);

bool is_in_convex(int px, int py);

void drawPolygonToBuffer(int count, ...);

pt_3d adjust(pt_3d p);

void opt_max(double *ts_k, double *u1);

void opt_min(double *ts_k, double *u2);

void reduce(int xmin, int xmax, int ymin, int ymax, int segx, int segy, int dx, int dy, double *result_x, double *result_y, double *result_x2, double *result_y2);

void project_front(pt_3d p);

void project_back(pt_3d p);

void project_seg(pt_3d p1, pt_3d p2, bool first) ;

void project_and_render(pt_3d p1, pt_3d p2, pt_3d p3, pt_3d p4);

void project_rectangle(pt_3d p1, pt_3d p2, pt_3d p3, pt_3d p4);

void resetBuffer();

void bufferUpdateRenderer(SDL_Renderer* renderer);

void destroy_3d();

void destroy_sincos();

#endif